/*
    Create and send spoofed tcp, udp and icmp packets

    by lamagra <access-granted@geocities.com>
    http://lamagra.seKure.de
*/

#include <sys/types.h>
#include <sys/socket.h>
#include <sys/wait.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <netinet/udp.h>
#include <netinet/ip_icmp.h>
#define __FAVOR_BSD
#include <netinet/tcp.h>
#include <netdb.h>
#include <stdio.h>

#define PSEUDOSIZ sizeof(struct pseudohdr)
#define IPHDRSIZ  sizeof(struct iphdr)
#define TCPHDRSIZ sizeof(struct tcphdr)
#define UDPHDRSIZ sizeof(struct udphdr)
#define ICMPHDRSIZ sizeof(struct icmphdr)

struct pseudohdr
{
  unsigned long saddr;
  unsigned long daddr;
  char useless;
  unsigned char protocol;
  unsigned short length;
};

unsigned short chksum(unsigned short *addr,int len)
{
   register int nleft = len;
   register unsigned short *w = addr;
   register int sum = 0;
   unsigned short answer = 0;

   while(nleft > 1)
   {
     sum += *w++;
     nleft -= 2;
   }

   if(nleft == 1)
   {
        *(unsigned char *)(&answer) = *(unsigned char *)w;
        sum += answer;
   }

   sum = (sum >> 16) + (sum & 0xffff);
   sum += (sum >> 16);
   answer = ~sum;
   return answer;
}

int send_udp(int sock, unsigned long saddr, unsigned short sport,
             unsigned long daddr, unsigned short dport, char *data,int datasize)
{
    int ret;
    struct sockaddr_in sin;
    struct pseudohdr *pseudo;
    struct udphdr *udp;
    struct iphdr *ip;
    char *packet,*pdata;

    packet = (char *)malloc(IPHDRSIZ + UDPHDRSIZ + datasize);
    if(!packet)
    {
        printf("Malloc error\n");
        exit(-1);
    }

    ip     = (struct iphdr *)packet;
    pseudo = (struct pseudohdr *)(packet + IPHDRSIZ - PSEUDOSIZ);
    udp    = (struct udphdr *)(packet + IPHDRSIZ);
    pdata  = (char *)(packet + IPHDRSIZ + UDPHDRSIZ);

    memset(packet,NULL,IPHDRSIZ + UDPHDRSIZ + datasize);
    if(data && datasize) memcpy(pdata,data,datasize);

    pseudo->saddr    = saddr;
    pseudo->daddr    = daddr;
    pseudo->useless  = 0;
    pseudo->protocol = IPPROTO_UDP;
    pseudo->length   = htons(UDPHDRSIZ + datasize);

    udp->source = htons(sport);
    udp->dest   = htons(dport);
    udp->len    = htons(UDPHDRSIZ + datasize);
    udp->check  = chksum((u_short *)pseudo,PSEUDOSIZ + UDPHDRSIZ + datasize);

    ip->version = 4;
    ip->ihl     = 5;
    ip->tos     = 0;
    ip->tot_len = htons(IPHDRSIZ + UDPHDRSIZ + datasize);
    ip->id      = htons(random());
    ip->frag_off= 0;
    ip->ttl     = 255;
    ip->protocol= IPPROTO_UDP;
    ip->saddr   = saddr;
    ip->daddr   = daddr;
    ip->check   = chksum((u_short *)packet,IPHDRSIZ);

    sin.sin_addr.s_addr = daddr;
    sin.sin_family = AF_INET;

    ret = sendto(sock,packet,IPHDRSIZ + UDPHDRSIZ + datasize,0,(struct sockaddr *)&sin,sizeof(struct sockaddr));
    free(packet);
    return ret;
}

int send_tcp(int sock,unsigned long source,unsigned long dest,
            unsigned short sport,unsigned short dport,unsigned char flags,
            unsigned long seq_num,unsigned long ack_num, unsigned short win,
            char *data, int datalen)
{
    struct sockaddr_in sin;
    struct iphdr *ip;
    struct tcphdr *tcp;
    struct pseudohdr *pseudo;
    char *packet, *pdata;
    int ret;

    packet = (char *)malloc(IPHDRSIZ + TCPHDRSIZ + datalen);
    if(!packet)
    {
        printf("Malloc error\n");
        exit(-1);
    }
    
    ip     = (struct iphdr *)packet;
    pseudo = (struct pseudohdr *)(packet + IPHDRSIZ - PSEUDOSIZ);
    tcp    = (struct tcphdr *)(packet + IPHDRSIZ);
    pdata  = (char *)(packet + IPHDRSIZ + TCPHDRSIZ);

    memset(packet,NULL,IPHDRSIZ + TCPHDRSIZ + datalen);
    if(data && datalen) memcpy(pdata,data,datalen);

    pseudo->saddr    = source;
    pseudo->daddr    = dest;
    pseudo->useless  = 0;
    pseudo->protocol = IPPROTO_TCP;
    pseudo->length   = htons(TCPHDRSIZ + datalen);

    tcp->th_sport = htons(sport);
    tcp->th_dport = htons(dport);
    tcp->th_seq   = htonl(seq_num);
    tcp->th_ack   = htonl(ack_num);
    tcp->th_off   = 5;
    tcp->th_flags = flags;
    tcp->th_win   = htons(win);
    tcp->th_urp   = 0;
    tcp->th_sum   = chksum((unsigned short *)pseudo,TCPHDRSIZ + PSEUDOSIZ + datalen);

    bzero(packet,IPHDRSIZ);

    ip->saddr     = source;
    ip->daddr     = dest;
    ip->version   = 4;
    ip->ihl       = 5;
    ip->ttl       = 245;
    ip->protocol  = IPPROTO_TCP;
    ip->tot_len   = htons(IPHDRSIZ + TCPHDRSIZ + datalen);
    ip->tos       = 0;
    ip->id        = rand() % 1256;
    ip->frag_off  = 0;
    ip->check     = chksum((unsigned short *)packet,IPHDRSIZ);

    sin.sin_addr.s_addr = ip->daddr;
    sin.sin_family = AF_INET;

    ret = sendto(sock,packet,IPHDRSIZ + TCPHDRSIZ + datalen,0,
                (struct sockaddr *)&sin,sizeof(struct sockaddr));
    free(packet);
    return ret;
}

int send_icmp(int sock, unsigned long source, unsigned long dest,
            int type, int code, int id, int seq, char *data, int datalen)
{
    struct iphdr *ip;
    struct icmphdr *icmp;
    char *pdata,*packet;
    int ret;
    struct sockaddr_in sin;

    packet = (char *)malloc(IPHDRSIZ + ICMPHDRSIZ + datalen);
    if(!packet)
    {
        printf("Malloc error\n");
        exit(-1);
    }

    ip    = (struct iphdr *)packet;
    icmp  = (struct icmphdr *)(packet + IPHDRSIZ);
    pdata = (char *)(packet + IPHDRSIZ + ICMPHDRSIZ);

    memset(packet,NULL,IPHDRSIZ + ICMPHDRSIZ + datalen);
    if(data && datalen) memcpy(pdata,data,datalen);

    icmp->code    = code;
    icmp->type    = type;
    icmp->un.echo.id = id;
    icmp->un.echo.sequence = seq;
    icmp->checksum = chksum((unsigned short *)icmp,ICMPHDRSIZ + datalen);

    ip->saddr     = source;
    ip->daddr     = dest;
    ip->version   = 4;
    ip->ihl       = 5;
    ip->ttl       = 245;
    ip->protocol  = IPPROTO_ICMP;
    ip->tot_len   = htons(IPHDRSIZ + ICMPHDRSIZ + datalen);
    ip->tos       = 0;
    ip->id        = rand() % 1256;
    ip->frag_off  = 0;
    ip->check     = chksum((unsigned short *)packet,IPHDRSIZ);

    sin.sin_addr.s_addr = ip->daddr;
    sin.sin_family = AF_INET;

    ret = sendto(sock,packet,IPHDRSIZ + ICMPHDRSIZ + datalen,0,
                (struct sockaddr *)&sin,sizeof(struct sockaddr));
    free(packet);
    return ret;
}


unsigned long resolve(char *name)
{
  struct hostent *hp;
  unsigned long ip;

  if((ip = inet_addr(name)) == -1)
  {
    if((hp = gethostbyname(name)) == NULL)
    {
        printf("Unable to resolve <%s>\n",name);
        exit(-1);
    }
    memcpy(&ip,hp->h_addr,4);
  }
  return ip;
}

unsigned long rand_ip()
{
    char tmp[20];

    sprintf(tmp,"%d.%d.%d.%d",rand() % 255,
                              rand() % 255,
                              rand() % 255,
                              rand() % 255);
    return inet_addr(tmp);
}

