/*
    Spoof packets and write them to the linklayer
    by lamagra <access-granted@geocities.com>
    http://lamagra.seKure.de
 */

#include <sys/time.h>
#include <netinet/if_ether.h>
#include <netinet/in.h>
#include <linux/sockios.h>
#include <net/if.h>
#include <net/if_arp.h>

struct link_int
{
  int fd;
  char device[50];
  int data; /* heheh, just for fun :-) */
};

struct link_int *open_lnk(char *device)
{
    struct link_int *l;

    l = (struct link_int *)malloc(sizeof (*l));
    if (l == NULL)
    {
        perror("malloc");
        return NULL;
    }
    
    memset(l, 0, sizeof (*l));
    strcpy(l->device,device);
    l->fd = socket(AF_INET, SOCK_PACKET, htons(ETH_P_ALL));
    if (l->fd == -1)
    {
        perror("socket");
        goto bad;
    }
    return l;

bad:
    if (l->fd >= 0)
    {
        close(l->fd);
    }
    free(l);
    return NULL;
}


int
close_lnk(struct link_int *l)
{
    return close(l->fd);
}


int
write_lnk(struct link_int *l, u_char *buf, int len)
{
    int c;
    struct sockaddr sa;

    memset(&sa, 0, sizeof (sa));
    strncpy(sa.sa_data, l->device, sizeof (sa.sa_data));

    l->data += len;

    return sendto(l->fd, buf, len, 0, &sa, sizeof (sa));
}

struct ether_addr *hwaddr(struct link_int *lnk)
{
    int sock;
    static struct ether_addr ethaddr;
    struct ifreq ifr;

    if ((sock = socket(AF_INET, SOCK_DGRAM, 0)) == -1)
    {
        return -1;
    }

    memset(&ifr, 0, sizeof(ifr));
    strncpy(ifr.ifr_name, lnk->device, sizeof(ifr.ifr_name));
    
    if(ioctl(sock, SIOCGIFHWADDR, (char *)&ifr) == -1)
    {
        close(sock);
        return -1;
    }
    close(sock);
    memcpy(&ethaddr, &ifr.ifr_hwaddr.sa_data, ETHER_ADDR_LEN);

    return &ethaddr;
}

unsigned long ipaddr(struct link_int *lnk)
{
    int sock;
    struct ifreq ifr;
    struct sockaddr_in *sin;

    if ((sock = socket(AF_INET, SOCK_DGRAM, 0)) == -1)
    {
        return -1;
    }

    memset((char *)&ifr, 0, sizeof(ifr));
    strncpy(ifr.ifr_name, lnk->device, sizeof(ifr.ifr_name));
    sin = (struct sockaddr_in *)&ifr.ifr_addr;
    sin->sin_family = AF_INET;
    
    if (ioctl(sock, SIOCGIFADDR, (char *)&ifr) == -1)
    {
        close(sock);
        return -1;
    }
    close(sock);
    return ntohl(sin->sin_addr.s_addr);
}

int arp_cache_lookup(char *device,u_long ip, struct ether_addr *ether)
{
  int sock;
  struct arpreq ar;
  struct sockaddr_in *sin;

  memset((char *)&ar, 0, sizeof(ar));
  strncpy(ar.arp_dev, device, sizeof(ar.arp_dev));
  sin = (struct sockaddr_in *)&ar.arp_pa;
  sin->sin_family = AF_INET;
  sin->sin_addr.s_addr = ip;
  
  if ((sock = socket(AF_INET, SOCK_DGRAM, 0)) == -1) {
    return (-1);
  }
  if (ioctl(sock, SIOCGARP, (caddr_t)&ar) == -1) {
    close(sock);
    return (-1);
  }
  close(sock);
  memcpy(ether->ether_addr_octet, ar.arp_ha.sa_data, ETHER_ADDR_LEN);
  
  return (0);
}
